SystemOrganization addCategory: #'Practica2Test-Ejercicio1'!
SystemOrganization addCategory: #'Practica2Test-Ejercicio2'!

Object subclass: #FabricaEmpleados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 02:48'!
EP1
	| ep1 |
	ep1 := EmpleadoPermanente new.
	ep1
		nombre: 'Betiana Rocha';
		direccion: 'Alcorta 1500';
		estadoCivil: 'Casada';
		fechaNacimiento: '23/10/1979';
		sueldoBasico: 8000;
		cantidadHijos: 2;
		antiguedad: 5.
	^ ep1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 02:50'!
EP2
	| ep2 |
	ep2 := EmpleadoPermanente new.
	ep2
		nombre: 'Cristian Cemero';
		direccion: 'Sabatini 640';
		estadoCivil: 'Soltero';
		fechaNacimiento: '14/09/1982';
		sueldoBasico: 6000;
		cantidadHijos: 0;
		antiguedad: 3.
	^ ep2! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 02:52'!
ET1
	| et1 |
	et1 := EmpleadoTemporario new.
	et1
		nombre: 'Laura Pozzi';
		direccion: 'Sucre 250';
		estadoCivil: 'Soltera';
		fechaNacimiento: '14/05/1980';
		sueldoBasico: 4000;
		finContrato: '01/01/2014';
		cantidadHorasExtra: 12.
	^ et1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 02:52'!
ET2
	| et2 |
	et2 := EmpleadoTemporario new.
	et2
		nombre: 'Juan Jos Lopez';
		direccion: 'Sarmiento 2450';
		estadoCivil: 'Casado';
		fechaNacimiento: '20/12/1950';
		sueldoBasico: 9000;
		finContrato: '01/01/2014';
		cantidadHorasExtra: 0.
	^ et2! !

TestCase subclass: #EmpresaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 02:52'!
testTotalSueldosBrutos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	sueldos brutos y se chequea que el valor devuelto sea el	esperado"

	| fabrica ep1 ep2 et1 et2 empresa totalSueldosBrutos |
	fabrica := FabricaEmpleados new.
	ep1 = fabrica EP1.
	ep2 = fabrica EP2.
	et1 = fabrica ET1.
	et2 = fabrica ET2.
	empresa := Empresa new.
	empresa
		addEmpleado: ep1;
		addEmpleado: ep2;
		addEmpleado: et1;
		addEmpleado: et2.
	totalSueldosBrutos = empresa calcularTotalSueldosBrutos.
	self assert: totalSueldosBrutos = 28280! !
